class Outcome

  attr_reader :success, :result, :messages, :errors, :warnings

  # Initializes an Outcome instance
  # @param[Boolean] success indicates if process was successful.
  # @param[Object] result the return value of the process. Anything you want to return
  # @param[Array<String>, optional] messages messages as Array of strings, optional
  # @param[Array<String>, optional] errors errors as Array of strings, optional
  # @param[Array<String>, optional] warnings warnings as Array of strings, optional
  def initialize(success, result, messages = [], errors = [], warnings = [])
    @success, @result, @messages, @errors, @warnings = success, result, messages, errors, warnings
  end

  def success?
    @success
  end

  def fail?
    !@success
  end

  def messages_to_html
    @messages.join('<br/>')
  end

end
